<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <!-- <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('中文标题')" prop="titleZh">
        <el-input v-model="queryParams.titleZh" :placeholder="$t('请输入中文标题')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('英文标题')" prop="titleEn">
        <el-input v-model="queryParams.titleEn" :placeholder="$t('请输入英文标题')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('有效期开始时间')" prop="validateStart">
        <el-input v-model="queryParams.validateStart" :placeholder="$t('请输入有效期开始时间')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('有效期结束时间')" prop="validateEnd">
        <el-input v-model="queryParams.validateEnd" :placeholder="$t('请输入有效期结束时间')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="web网页中文" prop="htmlWebZh">
        <el-input v-model="queryParams.htmlWebZh" placeholder="请输入web网页中文" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="web网页英文" prop="htmlWebEn">
        <el-input v-model="queryParams.htmlWebEn" placeholder="请输入web网页英文" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="app网页中文" prop="htmlAppZh">
        <el-input v-model="queryParams.htmlAppZh" placeholder="请输入app网页中文" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="0显示 1不显示" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择0显示 1不显示" clearable size="small">
          <el-option :label="$t('请选择字典生成')" value="" />
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('创建时间')">
        <el-date-picker v-model="dateRangeCreateTime" style="width: 240px" value-format="yyyy-MM-dd"
                        type="daterange" range-separator="-" start-:placeholder="$t('开始日期')" end-:placeholder="$t('结束日期')" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{$t('搜索')}}</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">{{$t('重置')}}</el-button>
      </el-form-item>
    </el-form> -->

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:banner-pop:create']">{{$t('新增')}}</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['ecw:banner-pop:export']">{{$t('导出')}}</el-button>
      </el-col> -->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="" align="center" prop="id" />
      <el-table-column :label="$t('弹窗标题')" align="center" prop="titleZh" />
      <el-table-column :label="$t('弹窗时间')" align="center" prop="validateDate" width="180">
        <template slot-scope="scope">
          <span>{{ formatTime(scope.row.validateStart) }}~{{ formatTime(scope.row.validateEnd) }}</span>
        </template>
      </el-table-column>

      <el-table-column :label="$t('状态')" align="center" prop="status">
        <template slot-scope="scope">
          <span>{{ statusName(scope.row.status) }}</span>
        </template>
      </el-table-column>

      <el-table-column :label="$t('创建时间')" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>

      <el-table-column :label="$t('操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
              <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:banner-pop:update']">{{$t('修改')}}</el-button>
              <el-button size="mini" type="text"  @click="handleStatus(scope.row)"
                     v-hasPermi="['ecw:banner-pop:update']">{{scope.row.status == CommonStatusEnum.ENABLE ? '禁用' : '启用'}}</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['ecw:banner-pop:delete']">{{$t('删除')}}</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.page" :limit.sync="queryParams.rows"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="900px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="标题(中文)" prop="titleZh">
          <el-input v-model="form.titleZh" :placeholder="$t('请输入中文标题')" />
        </el-form-item>
        <el-form-item label="标题(英文)" prop="titleEn">
          <el-input v-model="form.titleEn" :placeholder="$t('请输入英文标题')" />
        </el-form-item>
        <el-form-item :label="$t('有效期')" prop="validateStart">
          <el-date-picker type="datetime" :placeholder="$t('请选择日期')" value-format="yyyy-MM-dd HH:mm:ss" v-model="form.validateStart" @change="startChange">
          </el-date-picker>
          ~
          <el-date-picker type="datetime" :placeholder="$t('请选择日期')" value-format="yyyy-MM-dd HH:mm:ss" v-model="form.validateEnd">
          </el-date-picker>
          <span style="color:red;font-size:14px;">{{ $t('注意：留空则表示永久有效') }}</span>
        </el-form-item>

        <el-form-item :label="$t('网页中文')" prop="htmlWebZh">
          <editor v-model="form.htmlWebZh" :min-height="150"/>
        </el-form-item>
        <el-form-item :label="$t('网页英文')" prop="htmlWebEn">
          <editor v-model="form.htmlWebEn" :min-height="150"/>
        </el-form-item>
        <el-form-item label="APP中文" prop="htmlAppZh">
          <editor v-model="form.htmlAppZh" :min-height="150"/>
        </el-form-item>
        <el-form-item label="APP英文" prop="htmlAppEn">
           <editor v-model="form.htmlAppEn" :min-height="150"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{ $t('确 定') }}</el-button>
        <el-button @click="cancel">{{ $t('取 消') }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createBannerPop, updateBannerPop, deleteBannerPop, getBannerPop, getBannerPopPage, exportBannerPopExcel } from "@/api/ecw/bannerPop";
import Editor from '@/components/Editor';
import { getDictDatas, DICT_TYPE } from '@/utils/dict';
import {CommonStatusEnum} from '@/utils/constants'

export default {
  name: "BannerPop",
  components: {
    Editor,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 广告弹窗列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        // pageNo: 1,
        // pageSize: 10,
        page: 1,
        rows: 10,
        titleZh: null,
        titleEn: null,
        validateStart: null,
        validateEnd: null,
        htmlWebZh: null,
        htmlWebEn: null,
        htmlAppZh: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        titleZh: [{ required: true, message: this.$t("中文标题不能为空"), trigger: "blur" }],
        titleEn: [{ required: true, message: this.$t("英文标题不能为空"), trigger: "blur" }],
        validateStart: [{ required: true, message: this.$t("有效期开始时间不能为空"), trigger: "blur" }]
      },
      CommonStatusEnum: CommonStatusEnum,
      statusDictDatas: getDictDatas(DICT_TYPE.COMMON_STATUS),
    };
  },

  watch: {
      'form.validateStart'(newV, oldV) {
        if(this.form.validateStart && this.form.validateEnd) {
          let startDate = new Date(this.form.validateStart)
          let endDate = new Date(this.form.validateEnd)
          if(startDate.getTime() > endDate.getTime()){
            this.$message.error(this.$t('开始时间不能大于结束时间'));
            if(oldV) {
              this.form.validateStart = oldV;
            } else {
              this.form.validateStart = ""
            }
          }
        }
      },

      'form.validateEnd'(newV, oldV) {
        if(this.form.validateStart && this.form.validateEnd) {
          let startDate = new Date(this.form.validateStart)
          let endDate = new Date(this.form.validateEnd)
          if(startDate.getTime() > endDate.getTime()){
            this.$message.error(this.$t('结束时间不能小于开始时间'));
            if(oldV) {
              this.form.validateEnd= oldV;
            } else {
              this.form.validateEnd = ""
            }
          }
        }
      },

    },

  computed: {
    formatTime() {
      return millisecond => {
        if(millisecond) {
          return new Date(millisecond).format('yyyy-MM-dd hh:mm:ss');
        }
        return '';
      }
    },

    statusName() {
      return value => {
        for(let index in this.statusDictDatas) {
          let dictItem = this.statusDictDatas[index];
          if(dictItem.value == value) {
            return dictItem.value == CommonStatusEnum.ENABLE + '' ? this.$t('正常') : this.$t('禁用');
          }
        }
      }
    },
  },

  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getBannerPopPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        titleZh: undefined,
        titleEn: undefined,
        validateStart: undefined,
        validateEnd: undefined,
        htmlWebZh: undefined,
        htmlWebEn: undefined,
        htmlAppZh: undefined,
        status: undefined,
      };
      this.resetForm("form");
    },

    /**修改状态 */
    handleStatus(row) {
      row.status=row.status === CommonStatusEnum.ENABLE ? CommonStatusEnum.DISABLE : CommonStatusEnum.ENABLE;
      updateBannerPop(row).then(() => {
        this.$modal.msgSuccess(this.$t("修改成功"));
      }).catch(function() {
        row.status = row.status === CommonStatusEnum.ENABLE ? CommonStatusEnum.DISABLE : CommonStatusEnum.ENABLE;
      });
    },

    /**开始日期变了 */
    startChange(val) {

    },

    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = this.$t("添加广告弹窗");
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getBannerPop(id).then(response => {
        this.form = response.data;
		this.form.validateStart = this.parseTime(response.data.validateStart);
		this.form.validateEnd = this.parseTime(response.data.validateEnd);
		console.log(this.form);
        this.open = true;
        this.title = this.$t("修改广告弹窗");
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateBannerPop(this.form).then(response => {
            this.$modal.msgSuccess(this.$t("修改成功"));
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createBannerPop(this.form).then(response => {
          this.$modal.msgSuccess(this.$t("新增成功"));
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm(this.$t('是否确认删除广告弹窗编号为"') + id + this.$t('"的数据项?')).then(function() {
          return deleteBannerPop(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess(this.$t("删除成功"));
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm(this.$t('是否确认导出所有广告弹窗数据项?')).then(() => {
          this.exportLoading = true;
          return exportBannerPopExcel(params);
        }).then(response => {
          this.$download.excel(response, '${table.classComment}.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
